--- Mesa-7.8.2/src/mesa/glapi/gen/gl_SPARC_asm.py.orig	2010-06-16 03:43:42.000000000 +1000
+++ Mesa-7.8.2/src/mesa/glapi/gen/gl_SPARC_asm.py	2010-12-06 15:24:33.000000000 +1100
@@ -39,194 +39,194 @@
 
 
 	def printRealHeader(self):
-		print '#include "glapi/glapioffsets.h"'
-		print ''
-		print '#ifdef __arch64__'
-		print '#define GL_OFF(N)\t((N) * 8)'
-		print '#define GL_LL\t\tldx'
-		print '#define GL_TIE_LD(SYM)\t%tie_ldx(SYM)'
-		print '#define GL_STACK_SIZE\t128'
-		print '#else'
-		print '#define GL_OFF(N)\t((N) * 4)'
-		print '#define GL_LL\t\tld'
-		print '#define GL_TIE_LD(SYM)\t%tie_ld(SYM)'
-		print '#define GL_STACK_SIZE\t64'
-		print '#endif'
-		print ''
-		print '#define GLOBL_FN(x) .globl x ; .type x, @function'
-		print '#define HIDDEN(x) .hidden x'
-		print ''
-		print '\t.register %g2, #scratch'
-		print '\t.register %g3, #scratch'
-		print ''
-		print '\t.text'
-		print ''
-		print '\tGLOBL_FN(__glapi_sparc_icache_flush)'
-		print '\tHIDDEN(__glapi_sparc_icache_flush)'
-		print '\t.type\t__glapi_sparc_icache_flush, @function'
-		print '__glapi_sparc_icache_flush: /* %o0 = insn_addr */'
-		print '\tflush\t%o0'
-		print '\tretl'
-		print '\t nop'
-		print ''
-		print '\t.align\t32'
-		print ''
-		print '\t.type\t__glapi_sparc_get_pc, @function'
-		print '__glapi_sparc_get_pc:'
-		print '\tretl'
-		print '\t add\t%o7, %g2, %g2'
-		print '\t.size\t__glapi_sparc_get_pc, .-__glapi_sparc_get_pc'
-		print ''
-		print '#ifdef GLX_USE_TLS'
-		print ''
-		print '\tGLOBL_FN(__glapi_sparc_get_dispatch)'
-		print '\tHIDDEN(__glapi_sparc_get_dispatch)'
-		print '__glapi_sparc_get_dispatch:'
-		print '\tmov\t%o7, %g1'
-		print '\tsethi\t%hi(_GLOBAL_OFFSET_TABLE_-4), %g2'
-		print '\tcall\t__glapi_sparc_get_pc'
-		print '\tadd\t%g2, %lo(_GLOBAL_OFFSET_TABLE_+4), %g2'
-		print '\tmov\t%g1, %o7'
-		print '\tsethi\t%tie_hi22(_glapi_tls_Dispatch), %g1'
-		print '\tadd\t%g1, %tie_lo10(_glapi_tls_Dispatch), %g1'
-		print '\tGL_LL\t[%g2 + %g1], %g2, GL_TIE_LD(_glapi_tls_Dispatch)'
-		print '\tretl'
-		print '\t mov\t%g2, %o0'
-		print ''
-		print '\t.data'
-		print '\t.align\t32'
-		print ''
-		print '\t/* --> sethi %hi(_glapi_tls_Dispatch), %g1 */'
-		print '\t/* --> or %g1, %lo(_glapi_tls_Dispatch), %g1 */'
-		print '\tGLOBL_FN(__glapi_sparc_tls_stub)'
-		print '\tHIDDEN(__glapi_sparc_tls_stub)'
-		print '__glapi_sparc_tls_stub: /* Call offset in %g3 */'
-		print '\tmov\t%o7, %g1'
-		print '\tsethi\t%hi(_GLOBAL_OFFSET_TABLE_-4), %g2'
-		print '\tcall\t__glapi_sparc_get_pc'
-		print '\tadd\t%g2, %lo(_GLOBAL_OFFSET_TABLE_+4), %g2'
-		print '\tmov\t%g1, %o7'
-		print '\tsrl\t%g3, 10, %g3'
-		print '\tsethi\t%tie_hi22(_glapi_tls_Dispatch), %g1'
-		print '\tadd\t%g1, %tie_lo10(_glapi_tls_Dispatch), %g1'
-		print '\tGL_LL\t[%g2 + %g1], %g2, GL_TIE_LD(_glapi_tls_Dispatch)'
-		print '\tGL_LL\t[%g7+%g2], %g1'
-		print '\tGL_LL\t[%g1 + %g3], %g1'
-		print '\tjmp\t%g1'
-		print '\t nop'
-		print '\t.size\t__glapi_sparc_tls_stub, .-__glapi_sparc_tls_stub'
-		print ''
-		print '#define GL_STUB(fn, off)\t\t\t\t\\'
-		print '\tGLOBL_FN(fn);\t\t\t\t\t\\'
-		print 'fn:\tba\t__glapi_sparc_tls_stub;\t\t\t\\'
-		print '\t sethi\tGL_OFF(off), %g3;\t\t\t\\'
-		print '\t.size\tfn,.-fn;'
-		print ''
-		print '#elif defined(PTHREADS)'
-		print ''
-		print '\t/* 64-bit 0x00 --> sethi %hh(_glapi_Dispatch), %g1 */'
-		print '\t/* 64-bit 0x04 --> sethi %lm(_glapi_Dispatch), %g2 */'
-		print '\t/* 64-bit 0x08 --> or %g1, %hm(_glapi_Dispatch), %g1 */'
-		print '\t/* 64-bit 0x0c --> sllx %g1, 32, %g1 */'
-		print '\t/* 64-bit 0x10 --> add %g1, %g2, %g1 */'
-		print '\t/* 64-bit 0x14 --> ldx [%g1 + %lo(_glapi_Dispatch)], %g1 */'
-		print ''
-		print '\t/* 32-bit 0x00 --> sethi %hi(_glapi_Dispatch), %g1 */'
-		print '\t/* 32-bit 0x04 --> ld [%g1 + %lo(_glapi_Dispatch)], %g1 */'
-		print ''
-		print '\t.data'
-		print '\t.align\t32'
-		print ''
-		print '\tGLOBL_FN(__glapi_sparc_pthread_stub)'
-		print '\tHIDDEN(__glapi_sparc_pthread_stub)'
-		print '__glapi_sparc_pthread_stub: /* Call offset in %g3 */'
-		print '\tmov\t%o7, %g1'
-		print '\tsethi\t%hi(_GLOBAL_OFFSET_TABLE_-4), %g2'
-		print '\tcall\t__glapi_sparc_get_pc'
-		print '\t add\t%g2, %lo(_GLOBAL_OFFSET_TABLE_+4), %g2'
-		print '\tmov\t%g1, %o7'
-		print '\tsethi\t%hi(_glapi_Dispatch), %g1'
-		print '\tor\t%g1, %lo(_glapi_Dispatch), %g1'
-		print '\tsrl\t%g3, 10, %g3'
-		print '\tGL_LL\t[%g2+%g1], %g2'
-		print '\tGL_LL\t[%g2], %g1'
-		print '\tcmp\t%g1, 0'
-		print '\tbe\t2f'
-		print '\t nop'
-		print '1:\tGL_LL\t[%g1 + %g3], %g1'
-		print '\tjmp\t%g1'
-		print '\t nop'
-		print '2:\tsave\t%sp, GL_STACK_SIZE, %sp'
-		print '\tmov\t%g3, %l0'
-		print '\tcall\t_glapi_get_dispatch'
-		print '\t nop'
-		print '\tmov\t%o0, %g1'
-		print '\tmov\t%l0, %g3'
-		print '\tba\t1b'
-		print '\t restore %g0, %g0, %g0'
-		print '\t.size\t__glapi_sparc_pthread_stub, .-__glapi_sparc_pthread_stub'
-		print ''
-		print '#define GL_STUB(fn, off)\t\t\t\\'
-		print '\tGLOBL_FN(fn);\t\t\t\t\\'
-		print 'fn:\tba\t__glapi_sparc_pthread_stub;\t\\'
-		print '\t sethi\tGL_OFF(off), %g3;\t\t\\'
-		print '\t.size\tfn,.-fn;'
-		print ''
-		print '#else /* Non-threaded version. */'
-		print ''
-		print '\t.type	__glapi_sparc_nothread_stub, @function'
-		print '__glapi_sparc_nothread_stub: /* Call offset in %g3 */'
-		print '\tmov\t%o7, %g1'
-		print '\tsethi\t%hi(_GLOBAL_OFFSET_TABLE_-4), %g2'
-		print '\tcall\t__glapi_sparc_get_pc'
-		print '\t add\t%g2, %lo(_GLOBAL_OFFSET_TABLE_+4), %g2'
-		print '\tmov\t%g1, %o7'
-		print '\tsrl\t%g3, 10, %g3'
-		print '\tsethi\t%hi(_glapi_Dispatch), %g1'
-		print '\tor\t%g1, %lo(_glapi_Dispatch), %g1'
-		print '\tGL_LL\t[%g2+%g1], %g2'
-		print '\tGL_LL\t[%g2], %g1'
-		print '\tGL_LL\t[%g1 + %g3], %g1'
-		print '\tjmp\t%g1'
-		print '\t nop'
-		print '\t.size\t__glapi_sparc_nothread_stub, .-__glapi_sparc_nothread_stub'
-		print ''
-		print '#define GL_STUB(fn, off)\t\t\t\\'
-		print '\tGLOBL_FN(fn);\t\t\t\t\\'
-		print 'fn:\tba\t__glapi_sparc_nothread_stub;\t\\'
-		print '\t sethi\tGL_OFF(off), %g3;\t\t\\'
-		print '\t.size\tfn,.-fn;'
-		print ''
-		print '#endif'
-		print ''
-		print '#define GL_STUB_ALIAS(fn, alias)		\\'
-		print '	.globl	fn;				\\'
-		print '	.set	fn, alias'
-		print ''
-		print '\t.text'
-		print '\t.align\t32'
-		print ''
-		print '\t.globl\tgl_dispatch_functions_start'
-		print '\tHIDDEN(gl_dispatch_functions_start)'
-		print 'gl_dispatch_functions_start:'
-		print ''
+		print ('#include "glapi/glapioffsets.h"')
+		print ('')
+		print ('#ifdef __arch64__')
+		print ('#define GL_OFF(N)\t((N) * 8)')
+		print ('#define GL_LL\t\tldx')
+		print ('#define GL_TIE_LD(SYM)\t%tie_ldx(SYM)')
+		print ('#define GL_STACK_SIZE\t128')
+		print ('#else')
+		print ('#define GL_OFF(N)\t((N) * 4)')
+		print ('#define GL_LL\t\tld')
+		print ('#define GL_TIE_LD(SYM)\t%tie_ld(SYM)')
+		print ('#define GL_STACK_SIZE\t64')
+		print ('#endif')
+		print ('')
+		print ('#define GLOBL_FN(x) .globl x ; .type x, @function')
+		print ('#define HIDDEN(x) .hidden x')
+		print ('')
+		print ('\t.register %g2, #scratch')
+		print ('\t.register %g3, #scratch')
+		print ('')
+		print ('\t.text')
+		print ('')
+		print ('\tGLOBL_FN(__glapi_sparc_icache_flush)')
+		print ('\tHIDDEN(__glapi_sparc_icache_flush)')
+		print ('\t.type\t__glapi_sparc_icache_flush, @function')
+		print ('__glapi_sparc_icache_flush: /* %o0 = insn_addr */')
+		print ('\tflush\t%o0')
+		print ('\tretl')
+		print ('\t nop')
+		print ('')
+		print ('\t.align\t32')
+		print ('')
+		print ('\t.type\t__glapi_sparc_get_pc, @function')
+		print ('__glapi_sparc_get_pc:')
+		print ('\tretl')
+		print ('\t add\t%o7, %g2, %g2')
+		print ('\t.size\t__glapi_sparc_get_pc, .-__glapi_sparc_get_pc')
+		print ('')
+		print ('#ifdef GLX_USE_TLS')
+		print ('')
+		print ('\tGLOBL_FN(__glapi_sparc_get_dispatch)')
+		print ('\tHIDDEN(__glapi_sparc_get_dispatch)')
+		print ('__glapi_sparc_get_dispatch:')
+		print ('\tmov\t%o7, %g1')
+		print ('\tsethi\t%hi(_GLOBAL_OFFSET_TABLE_-4), %g2')
+		print ('\tcall\t__glapi_sparc_get_pc')
+		print ('\tadd\t%g2, %lo(_GLOBAL_OFFSET_TABLE_+4), %g2')
+		print ('\tmov\t%g1, %o7')
+		print ('\tsethi\t%tie_hi22(_glapi_tls_Dispatch), %g1')
+		print ('\tadd\t%g1, %tie_lo10(_glapi_tls_Dispatch), %g1')
+		print ('\tGL_LL\t[%g2 + %g1], %g2, GL_TIE_LD(_glapi_tls_Dispatch)')
+		print ('\tretl')
+		print ('\t mov\t%g2, %o0')
+		print ('')
+		print ('\t.data')
+		print ('\t.align\t32')
+		print ('')
+		print ('\t/* --> sethi %hi(_glapi_tls_Dispatch), %g1 */')
+		print ('\t/* --> or %g1, %lo(_glapi_tls_Dispatch), %g1 */')
+		print ('\tGLOBL_FN(__glapi_sparc_tls_stub)')
+		print ('\tHIDDEN(__glapi_sparc_tls_stub)')
+		print ('__glapi_sparc_tls_stub: /* Call offset in %g3 */')
+		print ('\tmov\t%o7, %g1')
+		print ('\tsethi\t%hi(_GLOBAL_OFFSET_TABLE_-4), %g2')
+		print ('\tcall\t__glapi_sparc_get_pc')
+		print ('\tadd\t%g2, %lo(_GLOBAL_OFFSET_TABLE_+4), %g2')
+		print ('\tmov\t%g1, %o7')
+		print ('\tsrl\t%g3, 10, %g3')
+		print ('\tsethi\t%tie_hi22(_glapi_tls_Dispatch), %g1')
+		print ('\tadd\t%g1, %tie_lo10(_glapi_tls_Dispatch), %g1')
+		print ('\tGL_LL\t[%g2 + %g1], %g2, GL_TIE_LD(_glapi_tls_Dispatch)')
+		print ('\tGL_LL\t[%g7+%g2], %g1')
+		print ('\tGL_LL\t[%g1 + %g3], %g1')
+		print ('\tjmp\t%g1')
+		print ('\t nop')
+		print ('\t.size\t__glapi_sparc_tls_stub, .-__glapi_sparc_tls_stub')
+		print ('')
+		print ('#define GL_STUB(fn, off)\t\t\t\t\\')
+		print ('\tGLOBL_FN(fn);\t\t\t\t\t\\')
+		print ('fn:\tba\t__glapi_sparc_tls_stub;\t\t\t\\')
+		print ('\t sethi\tGL_OFF(off), %g3;\t\t\t\\')
+		print ('\t.size\tfn,.-fn;')
+		print ('')
+		print ('#elif defined(PTHREADS)')
+		print ('')
+		print ('\t/* 64-bit 0x00 --> sethi %hh(_glapi_Dispatch), %g1 */')
+		print ('\t/* 64-bit 0x04 --> sethi %lm(_glapi_Dispatch), %g2 */')
+		print ('\t/* 64-bit 0x08 --> or %g1, %hm(_glapi_Dispatch), %g1 */')
+		print ('\t/* 64-bit 0x0c --> sllx %g1, 32, %g1 */')
+		print ('\t/* 64-bit 0x10 --> add %g1, %g2, %g1 */')
+		print ('\t/* 64-bit 0x14 --> ldx [%g1 + %lo(_glapi_Dispatch)], %g1 */')
+		print ('')
+		print ('\t/* 32-bit 0x00 --> sethi %hi(_glapi_Dispatch), %g1 */')
+		print ('\t/* 32-bit 0x04 --> ld [%g1 + %lo(_glapi_Dispatch)], %g1 */')
+		print ('')
+		print ('\t.data')
+		print ('\t.align\t32')
+		print ('')
+		print ('\tGLOBL_FN(__glapi_sparc_pthread_stub)')
+		print ('\tHIDDEN(__glapi_sparc_pthread_stub)')
+		print ('__glapi_sparc_pthread_stub: /* Call offset in %g3 */')
+		print ('\tmov\t%o7, %g1')
+		print ('\tsethi\t%hi(_GLOBAL_OFFSET_TABLE_-4), %g2')
+		print ('\tcall\t__glapi_sparc_get_pc')
+		print ('\t add\t%g2, %lo(_GLOBAL_OFFSET_TABLE_+4), %g2')
+		print ('\tmov\t%g1, %o7')
+		print ('\tsethi\t%hi(_glapi_Dispatch), %g1')
+		print ('\tor\t%g1, %lo(_glapi_Dispatch), %g1')
+		print ('\tsrl\t%g3, 10, %g3')
+		print ('\tGL_LL\t[%g2+%g1], %g2')
+		print ('\tGL_LL\t[%g2], %g1')
+		print ('\tcmp\t%g1, 0')
+		print ('\tbe\t2f')
+		print ('\t nop')
+		print ('1:\tGL_LL\t[%g1 + %g3], %g1')
+		print ('\tjmp\t%g1')
+		print ('\t nop')
+		print ('2:\tsave\t%sp, GL_STACK_SIZE, %sp')
+		print ('\tmov\t%g3, %l0')
+		print ('\tcall\t_glapi_get_dispatch')
+		print ('\t nop')
+		print ('\tmov\t%o0, %g1')
+		print ('\tmov\t%l0, %g3')
+		print ('\tba\t1b')
+		print ('\t restore %g0, %g0, %g0')
+		print ('\t.size\t__glapi_sparc_pthread_stub, .-__glapi_sparc_pthread_stub')
+		print ('')
+		print ('#define GL_STUB(fn, off)\t\t\t\\')
+		print ('\tGLOBL_FN(fn);\t\t\t\t\\')
+		print ('fn:\tba\t__glapi_sparc_pthread_stub;\t\\')
+		print ('\t sethi\tGL_OFF(off), %g3;\t\t\\')
+		print ('\t.size\tfn,.-fn;')
+		print ('')
+		print ('#else /* Non-threaded version. */')
+		print ('')
+		print ('\t.type	__glapi_sparc_nothread_stub, @function')
+		print ('__glapi_sparc_nothread_stub: /* Call offset in %g3 */')
+		print ('\tmov\t%o7, %g1')
+		print ('\tsethi\t%hi(_GLOBAL_OFFSET_TABLE_-4), %g2')
+		print ('\tcall\t__glapi_sparc_get_pc')
+		print ('\t add\t%g2, %lo(_GLOBAL_OFFSET_TABLE_+4), %g2')
+		print ('\tmov\t%g1, %o7')
+		print ('\tsrl\t%g3, 10, %g3')
+		print ('\tsethi\t%hi(_glapi_Dispatch), %g1')
+		print ('\tor\t%g1, %lo(_glapi_Dispatch), %g1')
+		print ('\tGL_LL\t[%g2+%g1], %g2')
+		print ('\tGL_LL\t[%g2], %g1')
+		print ('\tGL_LL\t[%g1 + %g3], %g1')
+		print ('\tjmp\t%g1')
+		print ('\t nop')
+		print ('\t.size\t__glapi_sparc_nothread_stub, .-__glapi_sparc_nothread_stub')
+		print ('')
+		print ('#define GL_STUB(fn, off)\t\t\t\\')
+		print ('\tGLOBL_FN(fn);\t\t\t\t\\')
+		print ('fn:\tba\t__glapi_sparc_nothread_stub;\t\\')
+		print ('\t sethi\tGL_OFF(off), %g3;\t\t\\')
+		print ('\t.size\tfn,.-fn;')
+		print ('')
+		print ('#endif')
+		print ('')
+		print ('#define GL_STUB_ALIAS(fn, alias)		\\')
+		print ('	.globl	fn;				\\')
+		print ('	.set	fn, alias')
+		print ('')
+		print ('\t.text')
+		print ('\t.align\t32')
+		print ('')
+		print ('\t.globl\tgl_dispatch_functions_start')
+		print ('\tHIDDEN(gl_dispatch_functions_start)')
+		print ('gl_dispatch_functions_start:')
+		print ('')
 		return
 
 	def printRealFooter(self):
-		print ''
-		print '\t.globl\tgl_dispatch_functions_end'
-		print '\tHIDDEN(gl_dispatch_functions_end)'
-		print 'gl_dispatch_functions_end:'
+		print ('')
+		print ('\t.globl\tgl_dispatch_functions_end')
+		print ('\tHIDDEN(gl_dispatch_functions_end)')
+		print ('gl_dispatch_functions_end:')
 		return
 
 	def printBody(self, api):
 		for f in api.functionIterateByOffset():
 			name = f.dispatch_name()
 
-			print '\tGL_STUB(gl%s, _gloffset_%s)' % (name, f.name)
+			print ('\tGL_STUB(gl%s, _gloffset_%s)' % (name, f.name))
 
 			if not f.is_static_entry_point(f.name):
-				print '\tHIDDEN(gl%s)' % (name)
+				print ('\tHIDDEN(gl%s)' % (name))
 
 		for f in api.functionIterateByOffset():
 			name = f.dispatch_name()
@@ -237,17 +237,17 @@
 						text = '\tGL_STUB_ALIAS(gl%s, gl%s)' % (n, f.name)
 
 						if f.has_different_protocol(n):
-							print '#ifndef GLX_INDIRECT_RENDERING'
-							print text
-							print '#endif'
+							print ('#ifndef GLX_INDIRECT_RENDERING')
+							print (text)
+							print ('#endif')
 						else:
-							print text
+							print (text)
 
 		return
 
 
 def show_usage():
-	print "Usage: %s [-f input_file_name] [-m output_mode]" % sys.argv[0]
+	print ("Usage: %s [-f input_file_name] [-m output_mode]" % sys.argv[0])
 	sys.exit(1)
 
 if __name__ == '__main__':
@@ -268,7 +268,7 @@
 	if mode == "generic":
 		printer = PrintGenericStubs()
 	else:
-		print "ERROR: Invalid mode \"%s\" specified." % mode
+		print ("ERROR: Invalid mode \"%s\" specified." % mode)
 		show_usage()
 
 	api = gl_XML.parse_GL_API(file_name, glX_XML.glx_item_factory())
--- Mesa-7.8.2/src/mesa/glapi/gen/gl_table.py.orig	2010-06-16 03:43:43.000000000 +1000
+++ Mesa-7.8.2/src/mesa/glapi/gen/gl_table.py	2010-12-06 15:23:46.000000000 +1100
@@ -45,26 +45,26 @@
 	def printBody(self, api):
 		for f in api.functionIterateByOffset():
 			arg_string = f.get_parameter_string()
-			print '   %s (GLAPIENTRYP %s)(%s); /* %d */' % (f.return_type, f.name, arg_string, f.offset)
+			print ('   %s (GLAPIENTRYP %s)(%s); /* %d */' % (f.return_type, f.name, arg_string, f.offset))
 
 
 	def printRealHeader(self):
-		print '#ifndef GLAPIENTRYP'
-		print '# ifndef GLAPIENTRY'
-		print '#  define GLAPIENTRY'
-		print '# endif'
-		print ''
-		print '# define GLAPIENTRYP GLAPIENTRY *'
-		print '#endif'
-		print ''
-		print ''
-		print 'struct _glapi_table'
-		print '{'
+		print ('#ifndef GLAPIENTRYP')
+		print ('# ifndef GLAPIENTRY')
+		print ('#  define GLAPIENTRY')
+		print ('# endif')
+		print ('')
+		print ('# define GLAPIENTRYP GLAPIENTRY *')
+		print ('#endif')
+		print ('')
+		print ('')
+		print ('struct _glapi_table')
+		print ('{')
 		return
 
 
 	def printRealFooter(self):
-		print '};'
+		print ('};')
 		return
 
 
@@ -80,7 +80,7 @@
 
 
 	def printRealHeader(self):
-		print """
+		print ("""
 /* this file should not be included directly in mesa */
 
 /**
@@ -93,27 +93,27 @@
  * can SET_FuncName, are used to get and set the dispatch pointer for the
  * named function in the specified dispatch table.
  */
-"""
+""")
 		
 		return
 
 	def printBody(self, api):
-		print '#define CALL_by_offset(disp, cast, offset, parameters) \\'
-		print '    (*(cast (GET_by_offset(disp, offset)))) parameters'
-		print '#define GET_by_offset(disp, offset) \\'
-		print '    (offset >= 0) ? (((_glapi_proc *)(disp))[offset]) : NULL'
-		print '#define SET_by_offset(disp, offset, fn) \\'
-		print '    do { \\'
-		print '        if ( (offset) < 0 ) { \\'
-		print '            /* fprintf( stderr, "[%s:%u] SET_by_offset(%p, %d, %s)!\\n", */ \\'
-		print '            /*         __func__, __LINE__, disp, offset, # fn); */ \\'
-		print '            /* abort(); */ \\'
-		print '        } \\'
-		print '        else { \\'
-		print '            ( (_glapi_proc *) (disp) )[offset] = (_glapi_proc) fn; \\'
-		print '        } \\'
-		print '    } while(0)'
-		print ''
+		print ('#define CALL_by_offset(disp, cast, offset, parameters) \\')
+		print ('    (*(cast (GET_by_offset(disp, offset)))) parameters')
+		print ('#define GET_by_offset(disp, offset) \\')
+		print ('    (offset >= 0) ? (((_glapi_proc *)(disp))[offset]) : NULL')
+		print ('#define SET_by_offset(disp, offset, fn) \\')
+		print ('    do { \\')
+		print ('        if ( (offset) < 0 ) { \\')
+		print ('            /* fprintf( stderr, "[%s:%u] SET_by_offset(%p, %d, %s)!\\n", */ \\')
+		print ('            /*         __func__, __LINE__, disp, offset, # fn); */ \\')
+		print ('            /* abort(); */ \\')
+		print ('        } \\')
+		print ('        else { \\')
+		print ('            ( (_glapi_proc *) (disp) )[offset] = (_glapi_proc) fn; \\')
+		print ('        } \\')
+		print ('    } while(0)')
+		print ('')
 
 		functions = []
 		abi_functions = []
@@ -133,70 +133,70 @@
 
 
 		for f in abi_functions:
-			print '#define CALL_%s(disp, parameters) (*((disp)->%s)) parameters' % (f.name, f.name)
-			print '#define GET_%s(disp) ((disp)->%s)' % (f.name, f.name)
-			print '#define SET_%s(disp, fn) ((disp)->%s = fn)' % (f.name, f.name)
+			print ('#define CALL_%s(disp, parameters) (*((disp)->%s)) parameters' % (f.name, f.name))
+			print ('#define GET_%s(disp) ((disp)->%s)' % (f.name, f.name))
+			print ('#define SET_%s(disp, fn) ((disp)->%s = fn)' % (f.name, f.name))
 
 
-		print ''
-		print '#if !defined(_GLAPI_USE_REMAP_TABLE)'
-		print ''
+		print ('')
+		print ('#if !defined(_GLAPI_USE_REMAP_TABLE)')
+		print ('')
 
 		for [f, index] in functions:
-			print '#define CALL_%s(disp, parameters) (*((disp)->%s)) parameters' % (f.name, f.name)
-			print '#define GET_%s(disp) ((disp)->%s)' % (f.name, f.name)
-			print '#define SET_%s(disp, fn) ((disp)->%s = fn)' % (f.name, f.name)
-
-		print ''
-		print '#else'
-		print ''
-		print '#define driDispatchRemapTable_size %u' % (count)
-		print 'extern int driDispatchRemapTable[ driDispatchRemapTable_size ];'
-		print ''
+			print ('#define CALL_%s(disp, parameters) (*((disp)->%s)) parameters' % (f.name, f.name))
+			print ('#define GET_%s(disp) ((disp)->%s)' % (f.name, f.name))
+			print ('#define SET_%s(disp, fn) ((disp)->%s = fn)' % (f.name, f.name))
+
+		print ('')
+		print ('#else')
+		print ('')
+		print ('#define driDispatchRemapTable_size %u' % (count))
+		print ('extern int driDispatchRemapTable[ driDispatchRemapTable_size ];')
+		print ('')
 
 		for [f, index] in functions:
-			print '#define %s_remap_index %u' % (f.name, index)
+			print ('#define %s_remap_index %u' % (f.name, index))
 
-		print ''
+		print ('')
 
 		for [f, index] in functions:
 			arg_string = gl_XML.create_parameter_string( f.parameters, 0 )
 			cast = '%s (GLAPIENTRYP)(%s)' % (f.return_type, arg_string)
 
-			print '#define CALL_%s(disp, parameters) CALL_by_offset(disp, (%s), driDispatchRemapTable[%s_remap_index], parameters)' % (f.name, cast, f.name)
-			print '#define GET_%s(disp) GET_by_offset(disp, driDispatchRemapTable[%s_remap_index])' % (f.name, f.name)
-			print '#define SET_%s(disp, fn) SET_by_offset(disp, driDispatchRemapTable[%s_remap_index], fn)' % (f.name, f.name)
+			print ('#define CALL_%s(disp, parameters) CALL_by_offset(disp, (%s), driDispatchRemapTable[%s_remap_index], parameters)' % (f.name, cast, f.name))
+			print ('#define GET_%s(disp) GET_by_offset(disp, driDispatchRemapTable[%s_remap_index])' % (f.name, f.name))
+			print ('#define SET_%s(disp, fn) SET_by_offset(disp, driDispatchRemapTable[%s_remap_index], fn)' % (f.name, f.name))
 
 
-		print ''
-		print '#endif /* !defined(_GLAPI_USE_REMAP_TABLE) */'
+		print ('')
+		print ('#endif /* !defined(_GLAPI_USE_REMAP_TABLE) */')
 
 		if alias_functions:
-			print ''
-			print '/* define aliases for compatibility */'
+			print ('')
+			print ('/* define aliases for compatibility */')
 			for f in alias_functions:
 				for name in f.entry_points:
 					if name != f.name:
-						print '#define CALL_%s(disp, parameters) CALL_%s(disp, parameters)' % (name, f.name)
-						print '#define GET_%s(disp) GET_%s(disp)' % (name, f.name)
-						print '#define SET_%s(disp, fn) SET_%s(disp, fn)' % (name, f.name)
-			print ''
+						print ('#define CALL_%s(disp, parameters) CALL_%s(disp, parameters)' % (name, f.name))
+						print ('#define GET_%s(disp) GET_%s(disp)' % (name, f.name))
+						print ('#define SET_%s(disp, fn) SET_%s(disp, fn)' % (name, f.name))
+			print ('')
 
-			print '#if defined(_GLAPI_USE_REMAP_TABLE)'
+			print ('#if defined(_GLAPI_USE_REMAP_TABLE)')
 			for f in alias_functions:
 				for name in f.entry_points:
 					if name != f.name:
-						print '#define %s_remap_index %s_remap_index' % (name, f.name)
-			print '#endif /* defined(_GLAPI_USE_REMAP_TABLE) */'
-			print ''
+						print ('#define %s_remap_index %s_remap_index' % (name, f.name))
+			print ('#endif /* defined(_GLAPI_USE_REMAP_TABLE) */')
+			print ('')
 
 		return
 
 
 def show_usage():
-	print "Usage: %s [-f input_file_name] [-m mode] [-c]" % sys.argv[0]
-	print "    -m mode   Mode can be 'table' or 'remap_table'."
-	print "    -c        Enable compatibility with OpenGL ES."
+	print ("Usage: %s [-f input_file_name] [-m mode] [-c]" % sys.argv[0])
+	print ("    -m mode   Mode can be 'table' or 'remap_table'.")
+	print ("    -c        Enable compatibility with OpenGL ES.")
 	sys.exit(1)
 
 if __name__ == '__main__':
